!=========================================================================
! Copyright (C) VMware, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: Warning.gs 27259 2011-11-09 22:12:54Z stever $
!
!=========================================================================

removeallmethods Warning
removeallclassmethods Warning

category: 'For Documentation Installation only'
classmethod: Warning
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'The class protocol describe the behavior of the global Warning. 
The value of the standard global Warning is a class object that 
conforms to this protocol. The class Warning is explicitly specified 
to be subclassable in a standard conforming program. Conforming 
implementations must implement its behaviors in a non-fragile manner.

The signaled exceptions generated by this type of object conform to 
the protocol <Warning>.

The instance protocol describes the behavior of instances of class 
Warning. These are used to represent exceptional conditions that 
might occur that are not considered errors but which should be 
reported to the user. Typically, the actual warning exceptions 
used by an application will be subclasses of this class.

As Warning is explicitly specified to be subclassable, conforming 
implementations must implement its behavior in a non-fragile manner.'.
doc documentClassWith: txt.

self description: doc.
%

category: 'ANSI - signaledException'
method: Warning
defaultAction
	"The user should be notified of the occurrence of an exceptional
	occurrence and given an option of continuing or aborting the
	computation. The description of the occurrence should include
	any text specified as the argument of the #signal: message.

	It is not so clear how this would be done in GemStone."

	^super defaultAction.
%
